<?php

namespace Picea\Ui\Form;

class UiTextarea extends UiInput {

    public array $tokens = [ "ui:textarea" ];

    public string $tag = "textarea";

    public array $attributes = [
       'class' => "ui-textarea",
    ];
    
    public array $options = [];

    protected bool $echoRaw = false;

    public function __construct(
        public bool $raw = false
    ) {
        parent::__construct(null);
    }

    public function parse(\Picea\Compiler\Context &$context, ?string $arguments, string $token, array $options = []) : string
    {
        $raw = in_array('raw', $options) ? 'true' : 'false';

        return "<?php echo ( new \\" . static::class . "(raw: $raw) )->buildHtml($arguments) ?>";
    }

    protected function setValue($value) : void
    {
        $this->echoRaw ? $this->html($value) : $this->text($value);
    }
}
